package luckyclient.execution.httpinterface;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import luckyclient.execution.dispose.ActionManageForSteps;
import luckyclient.execution.httpinterface.analyticsteps.InterfaceAnalyticCase;
import luckyclient.remote.api.GetServerApi;
import luckyclient.remote.entity.ProjectCase;
import luckyclient.remote.entity.ProjectCaseParams;
import luckyclient.remote.entity.ProjectCaseSteps;
import luckyclient.utils.InvokeMethod;
import luckyclient.utils.LogUtil;
import luckyclient.utils.httputils.HttpRequest;

/**
 * =================================================================
 * һƵκδǰ¶Գ޸ĺҵ;ҲԳ޸ĺκʽκĿĵٷ
 * ΪߵͶɹLuckyFrameؼȨϢϽ۸ κʻӭϵۡ QQ:1573584944 seagull1985
 * =================================================================
 * 
 * @ClassName: TestCaseDebug
 * @Description: ԶڱдУűе @author seagull
 * @date 201831
 * 
 */
public class ApiTestCaseDebug {
	private static final String ASSIGNMENT_SIGN = "$=";
	private static final String FUZZY_MATCHING_SIGN = "%=";
	private static final String REGULAR_MATCHING_SIGN = "~=";

	/**
	 * ڱ
	 * @param testCaseExternalId 
	 */
	public static void oneCaseDebug(String testCaseExternalId) {
		Map<String, String> variable = new HashMap<>(0);
		String packagename;
		String functionname;
		String expectedresults;
		int setcaseresult = 0;
		Object[] getParameterValues;
		String testnote = "ʼԽ";
		int k = 0;
		ProjectCase testcase = GetServerApi.cgetCaseBysign(testCaseExternalId);
		List<ProjectCaseParams> pcplist = GetServerApi.cgetParamsByProjectid(String.valueOf(testcase.getProjectId()));
		// ѹ뵽MAP
		for (ProjectCaseParams pcp : pcplist) {
			variable.put(pcp.getParamsName(), pcp.getParamsValue());
		}
		List<ProjectCaseSteps> steps = GetServerApi.getStepsbycaseid(testcase.getCaseId());
		if (steps.size() == 0) {
			setcaseresult = 2;
			LogUtil.APP.warn("δҵ裬飡");
			testnote = "δҵ裬飡";
		}
		// ѭв
		for (int i = 0; i < steps.size(); i++) {
			Map<String, String> casescript = InterfaceAnalyticCase.analyticCaseStep(testcase, steps.get(i), "888888",
					null,variable);
			try {
				packagename = casescript.get("PackageName");
				functionname = casescript.get("FunctionName");
			} catch (Exception e) {
				LogUtil.APP.error(":{} Ƿʧܣ飡",testcase.getCaseSign(),e);
				break; // ĳһʧܺ󣬴Ϊʧ˳
			}
			// ƽ쳣ǵ쳣
			if (functionname.contains("쳣") || k == 1) {
				testnote = "" + (i + 1) + "";
				break;
			}
			expectedresults = casescript.get("ExpectedResults");
			// жϷǷ
			if (casescript.size() > 4) {
				// ȡУʼ
				getParameterValues = new Object[casescript.size() - 4];
				for (int j = 0; j < casescript.size() - 4; j++) {
					if (casescript.get("FunctionParams" + (j + 1)) == null) {
						k = 1;
						break;
					}
					String parameterValues = casescript.get("FunctionParams" + (j + 1));
					LogUtil.APP.info(":{} :{} :{} {}:{}",testcase.getCaseSign(),packagename,functionname,(j+1),parameterValues);
					getParameterValues[j] = parameterValues;
				}
			} else {
				getParameterValues = null;
			}
			// öִ̬в
			try {
				LogUtil.APP.info("ʼ÷:{} .....",functionname);
				testnote = InvokeMethod.callCase(packagename, functionname, getParameterValues,
						steps.get(i).getStepType(), steps.get(i).getExtend());
				testnote = ActionManageForSteps.actionManage(casescript.get("Action"), testnote);
				if (null != expectedresults && !expectedresults.isEmpty()) {
					LogUtil.APP.info("expectedResults={}",expectedresults);
					// ֵ
					if (expectedresults.length() > ASSIGNMENT_SIGN.length()
							&& expectedresults.startsWith(ASSIGNMENT_SIGN)) {
						variable.put(expectedresults.substring(ASSIGNMENT_SIGN.length()), testnote);
						LogUtil.APP
								.info(":{} {}Խ{}ֵ{}",testcase.getCaseSign(),(i+1),testnote,expectedresults.substring(ASSIGNMENT_SIGN.length()));
					}
					// ģƥ
					else if (expectedresults.length() > FUZZY_MATCHING_SIGN.length()
							&& expectedresults.startsWith(FUZZY_MATCHING_SIGN)) {
						if (testnote.contains(expectedresults.substring(FUZZY_MATCHING_SIGN.length()))) {
							LogUtil.APP.info(
									":{} {}ģƥԤڽɹִн:{}",testcase.getCaseSign(),(i+1),testnote);
						} else {
							setcaseresult = 1;
							LogUtil.APP.warn(":{} {}ģƥԤڽʧܣԤڽ{}Խ:{}",testcase.getCaseSign(),(i+1),expectedresults.substring(FUZZY_MATCHING_SIGN.length()),testnote);
							testnote = "" + (i + 1) + "ģƥԤڽʧܣ";
			                if (testcase.getFailcontinue() == 0) {
			                    LogUtil.APP.warn("{}ڡ{}ִʧܣжϱִУ뵽һִ......",testcase.getCaseSign(),(i+1));
			                    break;
			                } else {
			                    LogUtil.APP.warn("{}ڡ{}ִʧܣִУ¸ִ......",testcase.getCaseSign(),(i+1));
			                }
						}
					}
					// ƥ
					else if (expectedresults.length() > REGULAR_MATCHING_SIGN.length()
							&& expectedresults.startsWith(REGULAR_MATCHING_SIGN)) {
						Pattern pattern = Pattern.compile(expectedresults.substring(REGULAR_MATCHING_SIGN.length()));
						Matcher matcher = pattern.matcher(testnote);
						if (matcher.find()) {
							LogUtil.APP.info(
									":{} {}ƥԤڽɹִн:{}",testcase.getCaseSign(),(i+1),testnote);
						} else {
							setcaseresult = 1;
							LogUtil.APP.warn(":{} {}ƥԤڽʧܣԤڽ:{}Խ:{}",testcase.getCaseSign(),(i+1),expectedresults.substring(REGULAR_MATCHING_SIGN.length()),testnote);
							testnote = "" + (i + 1) + "ƥԤڽʧܣ";
			                if (testcase.getFailcontinue() == 0) {
			                    LogUtil.APP.warn("{}ڡ{}ִʧܣжϱִУ뵽һִ......",testcase.getCaseSign(),(i+1));
			                    break;
			                } else {
			                    LogUtil.APP.warn("{}ڡ{}ִʧܣִУ¸ִ......",testcase.getCaseSign(),(i+1));
			                }
						}
					}
					// ȫ
					else {
						if (expectedresults.equals(testnote)) {
							LogUtil.APP.info(
									":{} {}ȷƥԤڽɹִн:{}",testcase.getCaseSign(),(i+1),testnote);
						} else {
							setcaseresult = 1;
							LogUtil.APP.warn(":{} {}ȷƥԤڽʧܣԤڽ:{}Խ:{}",testcase.getCaseSign(),(i+1),expectedresults,testnote);
							testnote = "" + (i + 1) + "ȷƥԤڽʧܣ";
			                if (testcase.getFailcontinue() == 0) {
			                    LogUtil.APP.warn("{}ڡ{}ִʧܣжϱִУ뵽һִ......",testcase.getCaseSign(),(i+1));
			                    break;
			                } else {
			                    LogUtil.APP.warn("{}ڡ{}ִʧܣִУ¸ִ......",testcase.getCaseSign(),(i+1));
			                }
						}
					}
				}
			} catch (Exception e) {
				setcaseresult = 1;
				LogUtil.APP.error("÷̳:{} ¼űԼ",functionname,e);
				testnote = "CallCaseó";
                if (testcase.getFailcontinue() == 0) {
                    LogUtil.APP.warn("{}ڡ{}ִʧܣжϱִУ뵽һִ......",testcase.getCaseSign(),(i+1));
                    break;
                } else {
                    LogUtil.APP.warn("{}ڡ{}ִʧܣִУ¸ִ......",testcase.getCaseSign(),(i+1));
                }
			}
		}
		variable.clear(); // մMAP
		// ÷δòԽ
		if (!testnote.contains("CallCaseó") && !testnote.contains("")) {
			LogUtil.APP.info("{}ɹɹз鿴ִн",testCaseExternalId);
		} else {
			LogUtil.APP.warn("{}ǵòеķ",testCaseExternalId);
		}
		if (0 == setcaseresult) {
			LogUtil.APP.info("{}ȫִгɹ",testCaseExternalId);
		} else {
			LogUtil.APP.warn("{}ִйʧܣ־",testCaseExternalId);
		}
	}

	/**
	 * ڱе
	 * @param projectname Ŀ
	 * @param addtestcase 
	 */
	public static void moreCaseDebug(String projectname, List<String> addtestcase) {
		System.out.println("ǰܹ"+addtestcase.size());
		for(String testCaseExternalId:addtestcase) {
			try {
				LogUtil.APP
						.info("ʼ÷Ŀ:{}:{}",projectname,testCaseExternalId);
				oneCaseDebug(testCaseExternalId);
			} catch (Exception e) {
				LogUtil.APP.error("Debug쳣",e);
			}
		}
	}

	/**
	 * ϵͳָԤڽ
	 */
	public static String setExpectedResults(String testCaseSign, int steps, String expectedResults) {
		String results;
		String params;
		try {
			expectedResults = expectedResults.replace("%", "BBFFHH");
			expectedResults = expectedResults.replace("=", "DHDHDH");
			expectedResults = expectedResults.replace("&", "ANDAND");
			params = "caseno=" + testCaseSign;
			params += "&stepnum=" + steps;
			params += "&expectedresults=" + expectedResults;
			results = HttpRequest.sendPost("/projectCasesteps/cUpdateStepExpectedResults.do", params);
		} catch (Exception e) {
			LogUtil.APP.error("ϵͳָԤڽ쳣",e);
			return "ϵͳָԤڽ쳣";
		}
		return results;

	}

}
